<?php declare(strict_types=1);

namespace Drupal\entity_usage_updater\Utility;

use Drupal\Core\Entity\EntityInterface;

/**
 * Provides a utility class for analyzing URLs.
 */
final class UrlHelper {

  /**
   * The inner helper object.
   *
   * @var UrlHelperInner|\Drupal\entity_usage\EntityUsageTrackBase
   */
  protected UrlHelperInner $inner;

  /**
   * Creates the helper object.
   */
  public function __construct() {
    $this->inner = UrlHelperInner::create(
      \Drupal::getContainer(),
      [],
      'url_helper (not real plugin)',
      []
    );
  }

  /**
   * Try to retrieve an entity from an URL string.
   *
   * @param string $url
   *   A relative or absolute URL string.
   *
   * @return \Drupal\Core\Entity\EntityInterface|null
   *   The entity object that corresponds to the received URL, or NULL if no
   *   entity could be retrieved.
   */
  public function findEntityByUrlString(string $url): ?EntityInterface {
    return $this->inner->findEntityByUrlString($url);
  }

}
