<?php declare(strict_types=1);

namespace Drupal\entity_usage_updater\Utility;

use Drupal\Core\Field\FieldItemInterface;
use Drupal\entity_usage\EntityUsageTrackBase;

/**
 * Exposes Entity Usage logic for extracting entity details from a URL string.
 *
 * This is an ugly approach in that it extends EntityUsageTrackBase while it
 * isn't an entity usage tracker. It should only be usd via UrlHelper which
 * hides irreleveant public methods. Ideally this functianality could be
 * factored out from the base class within Entity Usage itself.
 *
 * @internal
 */
final class UrlHelperInner extends EntityUsageTrackBase {

  /**
   * This shouldn't be used.
   */
  public function getTargetEntities(FieldItemInterface $item) {
    throw new \LogicException("This isn't a real tracker.");
  }

  /**
   * Try to retrieve an entity from an URL string.
   *
   * @param string $url
   *   A relative or absolute URL string.
   *
   * @return \Drupal\Core\Entity\EntityInterface|null
   *   The entity object that corresponds to the received URL, or NULL if no
   *   entity could be retrieved.
   */
  public function findEntityByUrlString($url) {
    return parent::findEntityByUrlString($url);
  }

}
